#!/bin/ksh
##################################################################################################################
#                             __                                                                                 #
#                            /_   / /  /_   /   /   _ /                    EUKLIDDesign                          #
#                           /_   /_/  / |  /_  /  /_ /                        Support                            #
#														 #
#                                 C A D  C A M                                                                  #
#														 #
#														 #
#     EUKLID Software GmbH					Tel. : +49 (0)8121 / 9924-10			 #
#     EUKLIDDesign Support					Fax. : +49 (0)8121 / 9924-99			 #
#     Gruber Str. 46B						EMail: EUKLIDDesign.Support@euklid-software.de	 #
#     D-85586 Poing						http : //euklid-software.de			 #
#														 #
##################################################################################################################
#														 #
#														 #
#     "plot.cmd"								     Mller	  24.10.2001	 #
#     ----------												 #
#														 #
#														 #
#     Der Script "plot.cmd" wird bei der Plotausleitung ber Formate aus EUKLID Design / Classic		 #
#     angestossen. Hier erfolgt in Abhngigkeit von den bergabeparameter die weitere Bearbeitung		 #
#     der erzeugten Plot-Dateien (cgm, ps, hpgl......).								 #
#														 #
#     Dieser Script ist auf jeden Fall den jeweiligen Gegebenheiten der Anwendungsumgebung anzupassen.		 #
#														 #
#     Anpassungen sind durchzufhren fr									 #
#														 #
#     	USER defined Par	-->	Anwenderspezifische Erweiterungen durch neue Parameter			 #
#     	DEFAULT VALUES		-->	bentigte Voreinstellungen wie Standarddrucker...	                 #
#														 #
#     In den einzelnen Ausgabe-Formaten sind die bentigten Kommandos aktiv zu setzen, oder sogar		 #
#     durch andere auszutauschen.										 #
#														 #
#     IMPORTANT INDICATIONS:											 #
#     Blanks in path-/filenames causes mistakes and are not allowed						 #
#														 #
##################################################################################################################





### =========================================   SPECIALS OF OPERATING SYSTEM   =========================

	typeset -l LOWWORD





### =========================================   EXAMINING OF HANDED OVER PARAMETERS   ==================

#:get_par
until	[[ $1 = ""  ]]						### no parameter more
do								### ------------------------------------
	LOWWORD=$1
								### Par1
								### get path and filename
								### ------------------------------------
	if  [[ -z $LWPATHFILE ]]	then LWPATHFILE=$1;   fi

								### Par2
								### get extension and format of output
								### ------------------------------------
	if [[ "$LOWWORD" = "ps"  ]]	then EXT=ps  ;	FORMAT=Postscript ;	fi
	if [[ "$LOWWORD" = "cps" ]]	then EXT=cps ;	FORMAT=Postscript ;	fi
	if [[ "$LOWWORD" = "hpg" ]]	then EXT=hpg ;	FORMAT=HP_GL      ;	fi
	if [[ "$LOWWORD" = "pff" ]]	then EXT=pff ;	FORMAT=I_Plot     ;	fi
	if [[ "$LOWWORD" = "cgm" ]]	then EXT=cgm ;	FORMAT=Sicad_Plot ;\
	
					XWIDTH=$2    ;	YWIDTH=$3         ;\
					shift        ;	shift             ;	fi


								### Par3<?
								### check for "form" from EUKLID Design
								### ------------------------------------
	if [[ "$LOWWORD" = "form" ]]	then SIZE=$2 ;	shift	;		fi

								### Par3<?
								### Pages(sides) to be printed
								### ------------------------------------
	if [[ "$LOWWORD" = "-n"*[0-9] ]] then PAGES=${LOWWORD#-n} ;		fi



	### ************* User defined Options *********************************************************
	
	
	 
								### Par3<?
								### check for other options
								### ------------------------------------
	if [[ "$LOWWORD" = "xxxx" ]]	then HOST=?XX? ; PRINTER=?XX? ;		fi
	if [[ "$LOWWORD" = "yyyy" ]]	then HOST=?YY? ; PRINTER=?YY? ;		fi

	
						###  In addition wished options are to be evaluated here



	### ************* User defined Options *********************************************************



#:new_par
	shift							### get next new parameter

#:end_par
done





### =========================================   DEFAULT VALUES   =======================================

						### Obligation parameter:  
						### default values if no parameter was handed over
						### Please, in each case adapt.
						### ----------------------------------------------------

								### Pages
								### Pages(sides) to be printed
								### ------------------------------------
	PAGES=${PAGES:=1}
								### Standard Host/Printer
								### for the respective format
								### ------------------------------------
	if  [[ -z $PRINTER ]]
	then
		if [[ "$FORMAT" = "Postscript" ]] then	HOST=?22? ; PRINTER=?22? ;	fi
		if [[ "$FORMAT" = "HP_GL"      ]] then	HOST=?33? ; PRINTER=?33? ;	fi
		if [[ "$FORMAT" = "I_Plot"     ]] then	HOST=?44? ; PRINTER=?44? ;	fi
		if [[ "$FORMAT" = "Sicad_Plot" ]] then	HOST=?55? ; PRINTER=?55? ;	fi
	fi





### =========================================   DO WHAT MUST BE DONE   =================================

						### 
						### 
						### 
						### ----------------------------------------------------
	FILE=$LWPATHFILE.$EXT
	

case $FORMAT in							### Examples of possible commands	
								### for more help see the Man Pages  
     ("EXAMPLES")						### man lp, man lpr........
								### ------------------------------------
		### SEND TO PRINTER
		    		 lp -c -d$PRINTER -n$PAGES  $FILE
		    rsh $HOST -n lp -c -d$PRINTER -n$PAGES  $FILE
		    		 lpr   -P$PRINTER -#$PAGES  $FILE
				 ...............
		;;	    

							### By delivery of new parameters the Postscript
							### Exit is to be examined and if necessary to 
							### adapt 
     ("Postscript")					### --------------------------------------------
 
		lp -c -d$PRINTER -n$PAGES  $FILE
		;;

							### By delivery of new parameters the HP-GL
							### Exit is to be examined and if necessary to 
							### adapt 
     ("HP_GL")						### --------------------------------------------

		lp -c -d$PRINTER -n$PAGES  $FILE
		;;	    

							### This Plot-exit is not supported any more
     ("I_Plot")						### --------------------------------------------

		#
		;;	    

							### By delivery of new parameters the Sicad Plot
							### Exit is to be examined and if necessary to 
							### adapt 
     ("Sicad_Plot")					### --------------------------------------------

			### Please see the next lines as an example for working with the
			### software PLOT V4.x from SICAD Geomatics
			### ----------------------------------------------------------------------

		PLOTPROG=plot_order
					### userid to be written in job file (char[15])
		UID="`whoami`"
					### Account to be written in job file (char[8]):
					#   the double $UID, $ACC
					#   has to be a unique identifier for the job
		ACC="$$"
					### Date for job. Plot needs the right format on this place
		DAT=`date '+%d%m%y'`
					### Time for job. Plot needs the right format on this place
		TIM=`date '+%H%M%S'`
					### Priority of the plot-job [1..9]
		PRIO=5
   					### Copies must be 1 less than the Number of the pages(sides)
		let COPIES=$PAGES-1
					### Format: [-5 .. 5] or special format -10
					### We use the special format: information about the size is 
					### specified by %3 and %4 as x- and y-ranges [in: mm]
		SFORMAT=-10 
					### Rotation 0.0 degree for "portrait" and -90.0 for "landscape"
		if  [[ "$XWIDTH" -lt "$YWIDTH" ]]  then ROT=0.0 ; else ROT=-90.0 ;  fi
			
					### Comment (char[32]) will be output by PLOTDISP
					### maybe the filename
					### BNK="`/bin/basename $File | awk '{print substr($0,1,32)}'`"
		BNK="?..?"
					### Another comment (char[160]):
		BEM=EUKLID_Design_2D_Classic
					### Erase cgm-file (J) or not (N) in the CGMDIR
		ERASE=J 


		$PLOTPROG -h $HOST -d $PRINTER $UID $ACC $DAT $TIM $PRIO $COPIES $SFORMAT $ROT $XWIDTH $YWIDTH $BNK $BEM $FILE $ERASE
		;;		
esac





### =========================================   EVERYTHING IS DONE   ===================================

#:END
   echo "@ $0"
   echo "  $FORMAT-Druckauftrag fuer $HOST:$PRINTER ausgefuehrt."
   echo "  Anzahl=$PAGES"

#:EOF
