// functions used in bom_tomodel.aql and bom_tofile.aql

/**************************************************************************************************/
function cut_blanks( blankstr )   // cut blanks at end of string
   i = len( blankstr )
   while i > 0 and substr(blankstr, i, i) = " " do
      i = i - 1
   end
   return ( substr(blankstr, 1, i) )
end
/**************************************************************************************************/
function build_groups(ElemGroup, var BalGroup)   // build group of symbol balloons
   for i in ElemGroup where not .deleted do
      if not (i in BalGroup) then
         switch i.type.name
            case "symbol" :
                 if i.tolsort = "balloon" then
                    BalGroup = BalGroup + i
                 end
            case "user" :
                 for j in i.list_symbol do
                    if j.tolsort = "balloon" then
                       BalGroup = BalGroup + j
                    end
                 end
            case "part" :
                 BalGroup = BalGroup + i.par_bal
         end
      end
   end
end
/**************************************************************************************************/
function sum_up( el, BalGroup, OldPos, OldId, var attrval )   // sum up quantity if real value
   if OldPos != el.symbol_Position or OldId != el.symbol_Identification then
      Quantity = 0.0
      for k in BalGroup where .symbol_Position = el.symbol_Position and
                              .symbol_Identification = el.symbol_Identification do
         if  k.symbol_Quantity_r != -1  then
            Quantity = Quantity + k.symbol_Quantity_r
         end
      end
      attrval = string( Quantity )
   end
end
/**************************************************************************************************/
function get_attrib_value( Obj, AttribGroupElem, Sum, BalGroup, OldPos, OldId, var AttrVal )   // sum up quantity if real value
   AttrVal = Obj.["symbol_" + AttribGroupElem.el_1]
   AttrRef = Obj.["ref_symbol_" + AttribGroupElem.el_1]
   if valid ( AttrVal ) then
      if AttribGroupElem.el_1 = "Quantity" and Sum then
         if  Obj.symbol_Quantity_r != -1  then
            sum_up( Obj, BalGroup, OldPos, OldId, AttrVal )
         else
            AttrVal = Obj.symbol_Quantity
         end
      end
   else if valid ( AttrRef ) then
      if AttrRef.type.name = "blstring" then
         AttrVal = AttrRef.data
      else
         AttrVal = AttrRef.["symbol_" + AttribGroupElem.el_1]
         ref_reference = AttrRef
         while not valid(AttrVal) and valid ( ref_reference ) do
            ref_reference = ref_reference.["ref_symbol_" + AttribGroupElem.el_1]
            if ref_reference.type.name = "blstring" then
               AttrVal = ref_reference.data
            else
               AttrVal = ref_reference.["symbol_" + AttribGroupElem.el_1]
            end
         end
      end
   else
      AttrVal = ""
   end end
end
